#include <stdio.h>
#include "shclib.h"

#define BLOCK_SIZE (19)

uchar raw_data[BLOCK_SIZE]="To be or not to be?";
uchar enc_data[BLOCK_SIZE+256];
uchar dec_data[BLOCK_SIZE];

int main(void)
{
    int i, enc_size, dec_size, next;

    printf("Raw data size: %d bytes\n", BLOCK_SIZE);
    printf("Raw data:\n");
    for (i=0; i<BLOCK_SIZE; i++) putchar(raw_data[i]);
    printf("\n\n");

    enc_size=sh_EncodeBlock(raw_data, enc_data, BLOCK_SIZE);

    printf("Encoded stream size: %d bytes\n", enc_size);
    printf("Encoded stream:\n");
    for (i=next=0; i<enc_size; i++) {
        printf("0x%0.2x ", enc_data[i]);
        next++; next%=4;
        if (!next) printf("\n");
    }

    printf("\n\n");

    dec_size=sh_DecodeBlock(enc_data, dec_data, enc_size);

    printf("Decoded stream size: %d bytes\n", dec_size);
    printf("Decoded data:\n");
    for (i=0; i<dec_size; i++) putchar(dec_data[i]);
    printf("\n\n");

    return 0;
}
